JackTrip: JackTrip Class Reference

JackTrip

Public Types | Public Slots | Signals | Public Member Functions | List of all members
JackTrip Class Reference

Main class to creates a SERVER (to listen) or a CLIENT (to connect to a listening server) to send audio streams in the network. More...

`#include <JackTrip.h>`

Inheritance diagram for JackTrip:
[legend]
Collaboration diagram for JackTrip:
[legend]

## Public Types
enum | dataProtocolT { UDP, TCP, SCTP }
| Enum for the data Protocol. At this time only UDP is implemented. More...
enum | jacktripModeT { SERVER, CLIENT, CLIENTTOPINGSERVER, SERVERPINGSERVER }
| Enum for the JackTrip mode. More...
enum | underrunModeT { WAVETABLE, ZEROS }
| Enum for the JackTrip Underrun Mode, when packets. More...
enum | audiointerfaceModeT { JACK, RTAUDIO }
| Enum for Audio Interface Mode. More...
enum | connectionModeT { NORMAL, KSTRONG, JAMTEST }
| Enum for Connection Mode (useful for connections to MultiClient Server) More...

## Public Slots
virtual void | slotStopProcesses ()
| Slot to stop all the processes and threads. More...
void | slotUdpWatingTooLong (int wait_msec)
| This slot emits in turn the signal signalNoUdpPacketsForSeconds when UDP has waited for more than 30 seconds. More...
void | slotPrintTest ()
void | slotReceivedConnectionFromPeer ()

## Signals
void | signalUdpTimeOut ()
void | signalProcessesStopped ()
| Signal emitted when all the processes and threads are stopped. More...
void | signalNoUdpPacketsForSeconds ()
| Signal emitted when no UDP Packets have been received for a while. More...
void | signalTcpClientConnected ()

## Public Member Functions
| JackTrip (jacktripModeT JacktripMode=CLIENT, dataProtocolT DataProtocolType=UDP, int NumChans=gDefaultNumInChannels, int BufferQueueLength=gDefaultQueueLength, unsigned int redundancy=gDefaultRedundancy, AudioInterface::audioBitResolutionT AudioBitResolution=AudioInterface::BIT16, DataProtocol::packetHeaderTypeT PacketHeaderType=DataProtocol::DEFAULT, underrunModeT UnderRunMode=WAVETABLE, int receiver_bind_port=gDefaultPort, int sender_bind_port=gDefaultPort, int receiver_peer_port=gDefaultPort, int sender_peer_port=gDefaultPort)
| The class Constructor with Default Parameters. More...
virtual | ~JackTrip ()
| The class destructor. More...
virtual void | run ()
| Starting point for the thread. More...
virtual void | setPeerAddress (const char *PeerHostOrIP)
| Set the Peer Address for jacktripModeT::CLIENT mode only. More...
virtual void | appendProcessPlugin (ProcessPlugin *plugin)
| Append a process plugin. Processes will be appended in order. More...
virtual void | startProcess () throw (std::invalid_argument)
| Start the processing threads. More...
virtual void | stop ()
| Stop the processing threads. More...
virtual void | waitThreads ()
| Wait for all the threads to finish. This functions is used when JackTrip is run as a thread. More...
virtual void | checkIfPortIsBinded (int port)
| Check if UDP port is already binded. More...
void | printTextTest ()
void | printTextTest2 ()
virtual void | setupAudio ()
| Set the AudioInteface object. More...
void | closeAudio ()
| Close the JackAudioInteface and disconnects it from JACK. More...
virtual void | setupDataProtocol ()
| Set the DataProtocol objects. More...
void | setupRingBuffers ()
| Set the RingBuffer objects. More...
void | clientStart () throw (std::invalid_argument)
| Starts for the CLIENT mode. More...
int | serverStart (bool timeout=false, int udpTimeout=gTimeOutMultiThreadedServer) throw (std::invalid_argument, std::runtime_error)
| Starts for the SERVER mode. More...
virtual int | clientPingToServerStart () throw (std::invalid_argument)
| Stats for the Client to Ping Server. More...
Getters and Setters Methods to change parameters after construction
virtual void | setJackTripMode (jacktripModeT JacktripMode)
| Sets (override) JackTrip Mode after construction. More...
virtual void | setDataProtocoType (dataProtocolT DataProtocolType)
| Sets (override) DataProtocol Type after construction. More...
virtual void | setPacketHeaderType (DataProtocol::packetHeaderTypeT PacketHeaderType)
| Sets the Packet header type. More...
virtual void | setBufferQueueLength (int BufferQueueLength)
| Sets (override) Buffer Queue Length Mode after construction. More...
virtual void | setAudioBitResolution (AudioInterface::audioBitResolutionT AudioBitResolution)
| Sets (override) Audio Bit Resolution after construction. More...
virtual void | setUnderRunMode (underrunModeT UnderRunMode)
| Sets (override) Underrun Mode. More...
virtual void | setAllPorts (int port)
| Sets port numbers for the local and peer machine. Receive port is `port` More...
virtual void | setBindPorts (int port)
| Sets port numbers to bind in RECEIVER and SENDER sockets. More...
virtual void | setPeerPorts (int port)
| Sets port numbers for the peer (remote) machine. More...
virtual void | setClientName (const char *ClientName)
| Set Client Name to something different that the default (JackTrip) More...
virtual void | setNumChannels (int num_chans)
| Set the number of audio channels. More...
virtual int | getReceiverBindPort () const
virtual int | getSenderPeerPort () const
virtual int | getSenderBindPort () const
virtual int | getReceiverPeerPort () const
virtual DataProtocol * | getDataProtocolSender () const
virtual DataProtocol * | getDataProtocolReceiver () const
virtual void | setDataProtocolSender (DataProtocol *const DataProtocolSender)
virtual void | setDataProtocolReceiver (DataProtocol *const DataProtocolReceiver)
virtual RingBuffer * | getSendRingBuffer () const
virtual RingBuffer * | getReceiveRingBuffer () const
virtual void | setSendRingBuffer (RingBuffer *const SendRingBuffer)
virtual void | setReceiveRingBuffer (RingBuffer *const ReceiveRingBuffer)
virtual void | setPacketHeader (PacketHeader *const PacketHeader)
virtual int | getRingBuffersSlotSize ()
virtual void | setAudiointerfaceMode (JackTrip::audiointerfaceModeT audiointerface_mode)
virtual void | setAudioInterface (AudioInterface *const AudioInterface)
void | setSampleRate (uint32_t sample_rate)
void | setAudioBufferSizeInSamples (uint32_t buf_size)
JackTrip::connectionModeT | getConnectionMode () const
void | setConnectionMode (JackTrip::connectionModeT connection_mode)
JackTrip::jacktripModeT | getJackTripMode () const
QString | getPeerAddress () const
bool | receivedConnectionFromPeer ()
bool | tcpConnectionError ()
Mediator Functions
virtual void | createHeader (const DataProtocol::packetHeaderTypeT headertype)
void | putHeaderInPacket (int8_t *full_packet, int8_t *audio_packet)
virtual int | getPacketSizeInBytes ()
void | parseAudioPacket (int8_t *full_packet, int8_t *audio_packet)
virtual void | sendNetworkPacket (const int8_t *ptrToSlot)
virtual void | receiveNetworkPacket (int8_t *ptrToReadSlot)
virtual void | readAudioBuffer (int8_t *ptrToReadSlot)
virtual void | writeAudioBuffer (const int8_t *ptrToSlot)
uint32_t | getBufferSizeInSamples () const
AudioInterface::samplingRateT | getSampleRateType () const
int | getSampleRate () const
uint8_t | getAudioBitResolution () const
unsigned int | getNumInputChannels () const
unsigned int | getNumOutputChannels () const
unsigned int | getNumChannels () const
virtual void | checkPeerSettings (int8_t *full_packet)
void | increaseSequenceNumber ()
int | getSequenceNumber () const
uint64_t | getPeerTimeStamp (int8_t *full_packet) const
uint16_t | getPeerSequenceNumber (int8_t *full_packet) const
uint16_t | getPeerBufferSize (int8_t *full_packet) const
uint8_t | getPeerSamplingRate (int8_t *full_packet) const
uint8_t | getPeerBitResolution (int8_t *full_packet) const
uint8_t | getPeerNumChannels (int8_t *full_packet) const
uint8_t | getPeerConnectionMode (int8_t *full_packet) const
size_t | getSizeInBytesPerChannel () const
int | getHeaderSizeInBytes () const
virtual int | getTotalAudioPacketSizeInBytes () const

## Detailed Description

Main class to creates a SERVER (to listen) or a CLIENT (to connect to a listening server) to send audio streams in the network.

All audio and network settings can be set in this class. This class also acts as a Mediator between all the other class. Classes that uses JackTrip methods need to register with it.

## Member Enumeration Documentation

## ◆ audiointerfaceModeT

enum JackTrip::audiointerfaceModeT

Enum for Audio Interface Mode.

Enumerator
JACK | Jack Mode.
RTAUDIO | RtAudio Mode.

## ◆ connectionModeT

enum JackTrip::connectionModeT

Enum for Connection Mode (useful for connections to MultiClient Server)

Enumerator
NORMAL | Normal Mode.
KSTRONG | Karplus Strong.
JAMTEST | Karplus Strong.

## ◆ dataProtocolT

enum JackTrip::dataProtocolT

Enum for the data Protocol. At this time only UDP is implemented.

Enumerator
UDP | Use UDP (User Datagram Protocol)
TCP | NOT IMPLEMENTED: Use TCP (Transmission Control Protocol)
SCTP | NOT IMPLEMENTED: Use SCTP (Stream Control Transmission Protocol)

## ◆ jacktripModeT

enum JackTrip::jacktripModeT

Enum for the JackTrip mode.

Enumerator
SERVER | Run in Server Mode.
CLIENT | Run in Client Mode.
CLIENTTOPINGSERVER | Client of the Ping Server Mode.
SERVERPINGSERVER | Server of the MultiThreaded JackTrip.

## ◆ underrunModeT

enum JackTrip::underrunModeT

Enum for the JackTrip Underrun Mode, when packets.

Enumerator
WAVETABLE | Loops on the last received packet.
ZEROS | Set new buffers to zero if there are no new ones.

## Constructor & Destructor Documentation

## ◆ JackTrip()

JackTrip::JackTrip | ( | jacktripModeT | JacktripMode = `CLIENT`,
|  | dataProtocolT | DataProtocolType = `UDP`,
|  | int | NumChans = `gDefaultNumInChannels`,
|  | int | BufferQueueLength = `gDefaultQueueLength`,
|  | unsigned int | redundancy = `gDefaultRedundancy`,
|  | AudioInterface::audioBitResolutionT | AudioBitResolution = `AudioInterface::BIT16`,
|  | DataProtocol::packetHeaderTypeT | PacketHeaderType = `DataProtocol::DEFAULT`,
|  | underrunModeT | UnderRunMode = `WAVETABLE`,
|  | int | receiver_bind_port = `gDefaultPort`,
|  | int | sender_bind_port = `gDefaultPort`,
|  | int | receiver_peer_port = `gDefaultPort`,
|  | int | sender_peer_port = `gDefaultPort`
| ) |  |

The class Constructor with Default Parameters.

Parameters

  JacktripMode | JackTrip::CLIENT or JackTrip::SERVER
  DataProtocolType | JackTrip::dataProtocolT
  NumChans | Number of Audio Channels (same for inputs and outputs)
  BufferQueueLength | Audio Buffer for receiving packets
  AudioBitResolution | Audio Sample Resolutions in bits
  redundancy | redundancy factor for network data

## ◆ ~JackTrip()

JackTrip::~JackTrip | ( |  | ) |
| virtual

The class destructor.

## Member Function Documentation

## ◆ appendProcessPlugin()

void JackTrip::appendProcessPlugin | ( | ProcessPlugin * | plugin | ) |
| virtual

Append a process plugin. Processes will be appended in order.

Parameters

  plugin | Pointer to ProcessPlugin Class

## ◆ checkIfPortIsBinded()

void JackTrip::checkIfPortIsBinded | ( | int | port | ) |
| virtual

Check if UDP port is already binded.

Parameters

  port | Port number

## ◆ checkPeerSettings()

void JackTrip::checkPeerSettings | ( | int8_t * | full_packet | ) |
| virtual

## ◆ clientPingToServerStart()

int JackTrip::clientPingToServerStart | ( |  | ) |
throw | ( | std::invalid_argument
| ) |  |
| virtual

Stats for the Client to Ping Server.

Returns
  -1 on error, 0 on success

## ◆ clientStart()

void JackTrip::clientStart | ( |  | ) |
throw | ( | std::invalid_argument
| ) |  |

Starts for the CLIENT mode.

## ◆ closeAudio()

void JackTrip::closeAudio | ( |  | ) |

Close the JackAudioInteface and disconnects it from JACK.

## ◆ createHeader()

void JackTrip::createHeader | ( | const DataProtocol::packetHeaderTypeT | headertype | ) |
| virtual

Todo:
  Document all these functions

## ◆ getAudioBitResolution()

uint8_t JackTrip::getAudioBitResolution | ( |  | ) | const
| inline

## ◆ getBufferSizeInSamples()

uint32_t JackTrip::getBufferSizeInSamples | ( |  | ) | const
| inline

## ◆ getConnectionMode()

JackTrip::connectionModeT JackTrip::getConnectionMode | ( |  | ) | const
| inline

## ◆ getDataProtocolReceiver()

virtual DataProtocol* JackTrip::getDataProtocolReceiver | ( |  | ) | const
| inlinevirtual

## ◆ getDataProtocolSender()

virtual DataProtocol* JackTrip::getDataProtocolSender | ( |  | ) | const
| inlinevirtual

## ◆ getHeaderSizeInBytes()

int JackTrip::getHeaderSizeInBytes | ( |  | ) | const
| inline

## ◆ getJackTripMode()

JackTrip::jacktripModeT JackTrip::getJackTripMode | ( |  | ) | const
| inline

## ◆ getNumChannels()

unsigned int JackTrip::getNumChannels | ( |  | ) | const
| inline

## ◆ getNumInputChannels()

unsigned int JackTrip::getNumInputChannels | ( |  | ) | const
| inline

## ◆ getNumOutputChannels()

unsigned int JackTrip::getNumOutputChannels | ( |  | ) | const
| inline

## ◆ getPacketSizeInBytes()

int JackTrip::getPacketSizeInBytes | ( |  | ) |
| virtual

## ◆ getPeerAddress()

QString JackTrip::getPeerAddress | ( |  | ) | const
| inline

## ◆ getPeerBitResolution()

uint8_t JackTrip::getPeerBitResolution | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getPeerBufferSize()

uint16_t JackTrip::getPeerBufferSize | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getPeerConnectionMode()

uint8_t JackTrip::getPeerConnectionMode | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getPeerNumChannels()

uint8_t JackTrip::getPeerNumChannels | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getPeerSamplingRate()

uint8_t JackTrip::getPeerSamplingRate | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getPeerSequenceNumber()

uint16_t JackTrip::getPeerSequenceNumber | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getPeerTimeStamp()

uint64_t JackTrip::getPeerTimeStamp | ( | int8_t * | full_packet | ) | const
| inline

## ◆ getReceiverBindPort()

virtual int JackTrip::getReceiverBindPort | ( |  | ) | const
| inlinevirtual

## ◆ getReceiveRingBuffer()

virtual RingBuffer* JackTrip::getReceiveRingBuffer | ( |  | ) | const
| inlinevirtual

## ◆ getReceiverPeerPort()

virtual int JackTrip::getReceiverPeerPort | ( |  | ) | const
| inlinevirtual

## ◆ getRingBuffersSlotSize()

virtual int JackTrip::getRingBuffersSlotSize | ( |  | ) |
| inlinevirtual

## ◆ getSampleRate()

int JackTrip::getSampleRate | ( |  | ) | const
| inline

## ◆ getSampleRateType()

AudioInterface::samplingRateT JackTrip::getSampleRateType | ( |  | ) | const
| inline

## ◆ getSenderBindPort()

virtual int JackTrip::getSenderBindPort | ( |  | ) | const
| inlinevirtual

## ◆ getSenderPeerPort()

virtual int JackTrip::getSenderPeerPort | ( |  | ) | const
| inlinevirtual

## ◆ getSendRingBuffer()

virtual RingBuffer* JackTrip::getSendRingBuffer | ( |  | ) | const
| inlinevirtual

## ◆ getSequenceNumber()

int JackTrip::getSequenceNumber | ( |  | ) | const
| inline

## ◆ getSizeInBytesPerChannel()

size_t JackTrip::getSizeInBytesPerChannel | ( |  | ) | const
| inline

## ◆ getTotalAudioPacketSizeInBytes()

virtual int JackTrip::getTotalAudioPacketSizeInBytes | ( |  | ) | const
| inlinevirtual

## ◆ increaseSequenceNumber()

void JackTrip::increaseSequenceNumber | ( |  | ) |
| inline

## ◆ parseAudioPacket()

void JackTrip::parseAudioPacket | ( | int8_t * | full_packet,
|  | int8_t * | audio_packet
| ) |  |

## ◆ printTextTest()

void JackTrip::printTextTest | ( |  | ) |
| inline

## ◆ printTextTest2()

void JackTrip::printTextTest2 | ( |  | ) |
| inline

## ◆ putHeaderInPacket()

void JackTrip::putHeaderInPacket | ( | int8_t * | full_packet,
|  | int8_t * | audio_packet
| ) |  |

## ◆ readAudioBuffer()

virtual void JackTrip::readAudioBuffer | ( | int8_t * | ptrToReadSlot | ) |
| inlinevirtual

## ◆ receivedConnectionFromPeer()

bool JackTrip::receivedConnectionFromPeer | ( |  | ) |
| inline

## ◆ receiveNetworkPacket()

virtual void JackTrip::receiveNetworkPacket | ( | int8_t * | ptrToReadSlot | ) |
| inlinevirtual

## ◆ run()

virtual void JackTrip::run | ( |  | ) |
| inlinevirtual

Starting point for the thread.

## ◆ sendNetworkPacket()

virtual void JackTrip::sendNetworkPacket | ( | const int8_t * | ptrToSlot | ) |
| inlinevirtual

## ◆ serverStart()

int JackTrip::serverStart | ( | bool | timeout = `false`,
|  | int | udpTimeout = `gTimeOutMultiThreadedServer`
| ) |  |
throw | ( | std::invalid_argument,
|  | std::runtime_error
| ) |  |

Starts for the SERVER mode.

Parameters

  timout | Set the server to timeout after 2 seconds if no client connections are received. Usefull for the multithreaded server

Returns
  0 on success, -1 on error

## ◆ setAllPorts()

virtual void JackTrip::setAllPorts | ( | int | port | ) |
| inlinevirtual

Sets port numbers for the local and peer machine. Receive port is `port`

## ◆ setAudioBitResolution()

virtual void JackTrip::setAudioBitResolution | ( | AudioInterface::audioBitResolutionT | AudioBitResolution | ) |
| inlinevirtual

Sets (override) Audio Bit Resolution after construction.

## ◆ setAudioBufferSizeInSamples()

void JackTrip::setAudioBufferSizeInSamples | ( | uint32_t | buf_size | ) |
| inline

## ◆ setAudioInterface()

virtual void JackTrip::setAudioInterface | ( | AudioInterface *const | AudioInterface | ) |
| inlinevirtual

## ◆ setAudiointerfaceMode()

virtual void JackTrip::setAudiointerfaceMode | ( | JackTrip::audiointerfaceModeT | audiointerface_mode | ) |
| inlinevirtual

## ◆ setBindPorts()

virtual void JackTrip::setBindPorts | ( | int | port | ) |
| inlinevirtual

Sets port numbers to bind in RECEIVER and SENDER sockets.

## ◆ setBufferQueueLength()

virtual void JackTrip::setBufferQueueLength | ( | int | BufferQueueLength | ) |
| inlinevirtual

Sets (override) Buffer Queue Length Mode after construction.

## ◆ setClientName()

virtual void JackTrip::setClientName | ( | const char * | ClientName | ) |
| inlinevirtual

Set Client Name to something different that the default (JackTrip)

## ◆ setConnectionMode()

void JackTrip::setConnectionMode | ( | JackTrip::connectionModeT | connection_mode | ) |
| inline

## ◆ setDataProtocolReceiver()

virtual void JackTrip::setDataProtocolReceiver | ( | DataProtocol *const | DataProtocolReceiver | ) |
| inlinevirtual

## ◆ setDataProtocolSender()

virtual void JackTrip::setDataProtocolSender | ( | DataProtocol *const | DataProtocolSender | ) |
| inlinevirtual

## ◆ setDataProtocoType()

virtual void JackTrip::setDataProtocoType | ( | dataProtocolT | DataProtocolType | ) |
| inlinevirtual

Sets (override) DataProtocol Type after construction.

## ◆ setJackTripMode()

virtual void JackTrip::setJackTripMode | ( | jacktripModeT | JacktripMode | ) |
| inlinevirtual

Sets (override) JackTrip Mode after construction.

## ◆ setNumChannels()

virtual void JackTrip::setNumChannels | ( | int | num_chans | ) |
| inlinevirtual

Set the number of audio channels.

## ◆ setPacketHeader()

virtual void JackTrip::setPacketHeader | ( | PacketHeader *const | PacketHeader | ) |
| inlinevirtual

## ◆ setPacketHeaderType()

virtual void JackTrip::setPacketHeaderType | ( | DataProtocol::packetHeaderTypeT | PacketHeaderType | ) |
| inlinevirtual

Sets the Packet header type.

## ◆ setPeerAddress()

void JackTrip::setPeerAddress | ( | const char * | PeerHostOrIP | ) |
| virtual

Set the Peer Address for jacktripModeT::CLIENT mode only.

## ◆ setPeerPorts()

virtual void JackTrip::setPeerPorts | ( | int | port | ) |
| inlinevirtual

Sets port numbers for the peer (remote) machine.

## ◆ setReceiveRingBuffer()

virtual void JackTrip::setReceiveRingBuffer | ( | RingBuffer *const | ReceiveRingBuffer | ) |
| inlinevirtual

## ◆ setSampleRate()

void JackTrip::setSampleRate | ( | uint32_t | sample_rate | ) |
| inline

## ◆ setSendRingBuffer()

virtual void JackTrip::setSendRingBuffer | ( | RingBuffer *const | SendRingBuffer | ) |
| inlinevirtual

## ◆ setUnderRunMode()

virtual void JackTrip::setUnderRunMode | ( | underrunModeT | UnderRunMode | ) |
| inlinevirtual

Sets (override) Underrun Mode.

## ◆ setupAudio()

void JackTrip::setupAudio | ( |  | ) |
| virtual

Set the AudioInteface object.

Todo:
  FIX THIS REPETITION OF CODE

## ◆ setupDataProtocol()

void JackTrip::setupDataProtocol | ( |  | ) |
| virtual

Set the DataProtocol objects.

## ◆ setupRingBuffers()

void JackTrip::setupRingBuffers | ( |  | ) |

Set the RingBuffer objects.

Todo:
  Make all this operations cleaner

## ◆ signalNoUdpPacketsForSeconds

void JackTrip::signalNoUdpPacketsForSeconds | ( |  | ) |
| signal

Signal emitted when no UDP Packets have been received for a while.

## ◆ signalProcessesStopped

void JackTrip::signalProcessesStopped | ( |  | ) |
| signal

Signal emitted when all the processes and threads are stopped.

## ◆ signalTcpClientConnected

void JackTrip::signalTcpClientConnected | ( |  | ) |
| signal

## ◆ signalUdpTimeOut

void JackTrip::signalUdpTimeOut | ( |  | ) |
| signal

## ◆ slotPrintTest

void JackTrip::slotPrintTest | ( |  | ) |
| inlineslot

## ◆ slotReceivedConnectionFromPeer

void JackTrip::slotReceivedConnectionFromPeer | ( |  | ) |
| inlineslot

## ◆ slotStopProcesses

virtual void JackTrip::slotStopProcesses | ( |  | ) |
| inlinevirtualslot

Slot to stop all the processes and threads.

## ◆ slotUdpWatingTooLong

void JackTrip::slotUdpWatingTooLong | ( | int | wait_msec | ) |
| inlineslot

This slot emits in turn the signal signalNoUdpPacketsForSeconds when UDP has waited for more than 30 seconds.

It is used to remove the thread from the server.

## ◆ startProcess()

void JackTrip::startProcess | ( |  | ) |
throw | ( | std::invalid_argument
| ) |  |
| virtual

Start the processing threads.

## ◆ stop()

void JackTrip::stop | ( |  | ) |
| virtual

Stop the processing threads.

## ◆ tcpConnectionError()

bool JackTrip::tcpConnectionError | ( |  | ) |
| inline

## ◆ waitThreads()

void JackTrip::waitThreads | ( |  | ) |
| virtual

Wait for all the threads to finish. This functions is used when JackTrip is run as a thread.

## ◆ writeAudioBuffer()

virtual void JackTrip::writeAudioBuffer | ( | const int8_t * | ptrToSlot | ) |
| inlinevirtual

The documentation for this class was generated from the following files:

- src/JackTrip.h
- src/JackTrip.cpp
- src/release/moc_JackTrip.cpp